/*
  SetColor.cpp

  Implementation of the SetColor function
*/

#include <stdio.h>

#include "TGAFile.h"

/*
void SetColor(const int x,
              const int y,
              RGBQUAD* pColor)

set the color of a pixel

Parameters:
x                      const int       x coordinate of pixel requested
y                      const int       y coordinate of pixel requested
pColor                 RGBQUAD*        Address of target byte triple

Return value: none

Global variables affected: none
*/
void TGAFile::SetColor(const int x, const int y, RGBQUAD* pColor)
{
  if((x >= 0) && (x < m_pHeader->image_width) && (y >= 0) && (y < m_pHeader->image_height))
  {
    unsigned char* pPos1;
    unsigned char* pPos2;
    int i;

    pPos1 = m_pData + y * m_dwWidthDWORDAligned + x * m_nBytesPerPixel;
    pPos2 = (unsigned char *)pColor;
    /* Get from pColor. */
    for(i = 0; i < m_nBytesPerPixel; i++)
    {
      *pPos1++ = *pPos2++; /* BLUE, GREEN, RED [, ALPHA]  */
    }
  }
#ifdef _DEBUG
  else
  {
//    fprintf(stderr,
//            "Error: Overflow in TGAFile::SetColor(%d, %d) - file size is only (%d, %d).\n",
//            x, y, m_pHeader->image_width, m_pHeader->image_height);
  }
#endif
}
