// AddTga.cpp: implementation file

#include "stdafx.h"

#include <afxtempl.h>
#include <float.h>

#include <list>
#include "Waypoint.h"

#include "geoDataClient.h"
#include "geoDataClientDialog.h"
#include "HTTPRequest.h"

// Add (tile) a TGA file to another one.
int CgeoDataClientDialog::AddTga(const CString &tgaFilenameToBeAdded,
                                 const CString &tgaFilenameOriginal,
                                 int xOffset,
                                 int yOffset,
                                 int finalWidth,
                                 int finalHeight)
{
  CString message;
  message.Format(_T("Adding \"%s\" to \"%s\" at (%d/%d)."),
                 tgaFilenameToBeAdded,
                 tgaFilenameOriginal,
                 xOffset,
                 yOffset);
  addMessage(message);

  TGAFile tgaFileToBeAdded;
  TGAFile tgaFileOriginal;

  if(tgaFileToBeAdded.Open(tgaFilenameToBeAdded))
  {
    message.Format(_T("Error in CombineTga(): Could not open file \"%s\"."), tgaFilenameToBeAdded);
    addMessage(message);
    return 1;
  }
  int  nWidth = tgaFileToBeAdded.GetImageWidth();
  int nHeight = tgaFileToBeAdded.GetImageHeight();
  if(tgaFileOriginal.Open(tgaFilenameOriginal))
  {
    tgaFileOriginal.New(finalWidth, finalHeight);
  }
  for(int y = 0; y < nHeight; y++)
  {
    for(int x = 0; x < nWidth; x++)
    {
      RGBQUAD Color;
      tgaFileToBeAdded.GetColor(x, y, &Color);
      tgaFileOriginal.SetColor(x + xOffset, y + yOffset, &Color);
    }
  }
  if(tgaFileOriginal.Write(tgaFilenameOriginal))
  {
    message.Format(_T("Error in AddTga(): Could not write file \"%s\"."), tgaFilenameOriginal);
    addMessage(message);
    return 3;
  }
  message.Format(_T("Adding successful: \"%s\" written."),
                 tgaFilenameOriginal);
  addMessage(message);
  return 0;
}
