// SeamlessQueryThread.cpp: implementation file
//

#include "stdafx.h"

#include <math.h>

#include <afxtempl.h>

#include <list>
#include "Waypoint.h"

#include "geoDataClient.h"
#include "geoDataClientDialog.h"
#include "HTTPRequest.h"
#include "RemoveDir.h"

extern "C"
{
	#include "unzip.h"
}

// The static thread function. Calls CgeoDataClientDialog::SeamlessQuery().
// Returns the number of errors or 0 if OK.
UINT CgeoDataClientDialog::SeamlessQueryThread(LPVOID pParam)
{
  CgeoDataClientDialog *geoDataClientDialog = (CgeoDataClientDialog *)(pParam);
  geoDataClientDialog->cancelButton.EnableWindow(FALSE);
  UINT result = geoDataClientDialog->SeamlessQuery();
  return result;
}

// The non-static thread function.
// Returns the number of errors or 0 if OK.
UINT CgeoDataClientDialog::SeamlessQuery()
{
//  CString message;
//  listBox.GetText(listBox.GetCurSel(), message);
  double   left = quadLeft;
  double  right = quadRight;
  double    top = quadTop;
  double bottom = quadBottom;

  CString key19Digits;
  for(int i = 0; i < 19; i++)
  {
		int r = rand() % 256;
		CString hexChar;
		hexChar.Format("%02x", r);
		key19Digits += hexChar;
  }
  CString message;
  
/*
  CString key19Digits;
  if(message.Find("  quad: ") == 0)
  {
    // Get seamless data.
    sscanf(message, "  quad: %lf, %lf, %lf, %lf", &left, &right, &top, &bottom);
    // Here a failsafe point is built in:
    // No quad download wider or higher than 1 degree allowed.
    if((right - left > 1.0) || (top - bottom > 1.0))
    {
      CString message;
      message.Format(_T("Error:\n"
                     "The quad is wider or higher than one degree:\n"
                     "Top left corner: %lf/%lf\n"
                     "Bottom right corner: %lf/%lf"),
                     left, top, right, bottom);
      addMessage(message);
      SetStateError();
      return 2;
    }
    for(int i = 0; i < 19; i++)
    {
		  int r = rand() % 256;
		  CString hexChar;
		  hexChar.Format("%02x", r);
		  key19Digits += hexChar;
    }
  }
  else
  {
    // Do nothing. This should not happen at all.
    CString message;
    message.Format(_T("Could not locate the key word \"  quad: \" (BIG ERROR)."));
    addMessage(message);
    message.Format(_T("Please copy the log file to the clipboard and contact support."));
    addMessage(message);
    SetStateError();
    
    return 1;
  }
*/

  closeButton.EnableWindow(FALSE);
  proceedButton.EnableWindow(FALSE);
	CWnd *pLeft = GetDlgItem(IDC_EDIT_LEFT);
	if(pLeft) pLeft->EnableWindow(FALSE);
	CWnd *pTop = GetDlgItem(IDC_EDIT_TOP);
	if(pTop) pTop->EnableWindow(FALSE);
  allowedToEnableProceedButton = false; // Don't allow to enable that button until further notice.
  cancelButton.EnableWindow();

  CList<CString,CString&> progressInformationText;
  progressInformationText.AddHead(CString("Adding your request"));
  progressInformationText.AddHead(CString("Extracting data"));
  progressInformationText.AddHead(CString("Extracting Metadata"));
  progressInformationText.AddHead(CString("Creating the archive file"));
  progressInformationText.AddHead(CString("Producing extract area"));
  progressInformationText.AddHead(CString("Raster Extract has completed"));
  progressInformationText.AddHead(CString("The data extraction has completed"));
  progressInformationText.AddHead(CString("ahead of you"));
  progressInformationText.AddHead(CString("Error"));
  CHTTPRequest request(listBox,
                       maxListboxTextExtent,
                       bCancel,
                       progressControl,
                       progressInformationText,
                       nHTTPTimeout);
  CString querySeamless; // The Seamless query: http://extract.cr.usgs.gov
// SRTM 1 arc sec - Shuttle Radar Topography Mission [Finished]:
  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=SM3&ras=1&rsp=1&pfm=BIL_16INT&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=SRTM1FIN&mdf=HTML&arc=ZIP&sde=SRTM.C_US_1_ELEVATION_SHIFT&msd=SRTM.c_national_1_elevation_meta&zun=&prj=0&csx=0.0002777777778&csy=0.0002777777778&bnd=&bndnm=&RC=%s",
                        left, right, top, bottom, key19Digits);
// DOQQ 1.0m B&W - UTM Zone 11:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=QBK&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=DOQQBW&mdf=HTML&arc=ZIP&sde=DOQQ.DOQQ_035_BW&msd=DOQQ.doqqbw_meta&zun=null&prj=0&csx=1.0&csy=1.0&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// DOQQ 1.0m Color - UTM Zone 11:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=QCF&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=DOQQ&mdf=HTML&arc=ZIP&sde=DOQQ.DOQQ_034&msd=DOQQ.doqq_meta&zun=null&prj=0&csx=1.0&csy=1.0&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// Jan 2006 Color Orthoimagery - Los Angeles County, CA:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=V22&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=ST_104_003&mdf=HTML&arc=ZIP&sde=ORTHO_ST.ST_ORTHO_104_005&msd=&zun=null&prj=0&csx=0.3048&csy=0.3048&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// National Atlas Streams:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=IB9&ras=0&rsp=0&pfm=Shapefile&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=IB9&mdf=HTML&arc=ZIP&sde=ATLAS.atlas_streams_waterbodies_l&msd=null&zun=null&prj=0&csx=0.0&csy=0.0&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// National Atlas Railroads:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=IB7&ras=0&rsp=0&pfm=Shapefile&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=IB7&mdf=HTML&arc=ZIP&sde=ATLAS.atlas_railroad&msd=null&zun=null&prj=0&csx=0.0&csy=0.0&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// National Atlas Roads:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=IB8&ras=0&rsp=0&pfm=Shapefile&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=IB8&mdf=HTML&arc=ZIP&sde=ATLAS.atlas_roads&msd=null&zun=null&prj=0&csx=0.0&csy=0.0&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// National Elevation Dataset (NED) 1/9 Arc Second:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=ND9&ras=1&rsp=1&pfm=BIL&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=NED19&mdf=HTML&arc=ZIP&sde=NED.CONUS_NED_19_MD&msd=NED.conus_ned_19_metaplygn&zun=METERS&prj=0&csx=3.08641975309901E-5&csy=3.08641975309901E-5&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// Mar 2005 Color Orthoimagery - Washington, DC:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=u1o&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=UA_346_06&mdf=HTML&arc=ZIP&sde=WEBMAP.UA_ORTHO_346_06&msd=&zun=null&prj=0&csx=0.16&csy=0.16&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// DOQQ 1.0m Color - UTM Zone 18 (Washington, DC):
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=QCB&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=DOQQ&mdf=HTML&arc=ZIP&sde=DOQQ.DOQQ_281&msd=DOQQ.doqq_meta&zun=null&prj=0&csx=1.0&csy=1.0&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// Landsat Mosaic:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=LS7&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=L7&mdf=HTML&arc=ZIP&sde=WEBMAP.LANDSAT_LZ77&msd=&zun=NULL&prj=0&csx=2.7777000000000005E-4&csy=2.7777000000000005E-4&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// Sep 2005 Color Orthoimagery - Washington, DC (0.5 m):
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=u1s&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=UA_346_05&mdf=HTML&arc=ZIP&sde=WEBMAP.UA_ORTHO_346_05&msd=&zun=null&prj=0&csx=0.5&csy=0.5&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// DGI02HZ...24k DRG - UTM Zone 18:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=DGI&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=DRG24kZ18&mdf=HTML&arc=ZIP&sde=DRG.Z18_24&msd=DRG.Z18_24_meta&zun=null&prj=0&csx=2.4384&csy=2.4384&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// DFI02HZ...100k DRG - UTM Zone 18:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=DFI&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=DRG100kZ18&mdf=HTML&arc=ZIP&sde=DRG.Z18_100&msd=DRG.Z18_100_meta&zun=null&prj=0&csx=10.16&csy=10.16&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// DER02HZ...250k DRG - UTM Zone 18:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=DER&ras=1&rsp=0&pfm=GeoTIFF&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=DRG250kZ18&mdf=HTML&arc=ZIP&sde=DRG.Z18_250&msd=DRG.Z18_250_meta&zun=null&prj=0&csx=25.4&csy=25.4&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// ND303HZ...National Elevation Dataset (NED) 1/3 Arc Second:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=ND3&ras=1&rsp=1&pfm=BIL&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=NED13&mdf=HTML&arc=ZIP&sde=NED.conus_ned_13e&msd=NED.CONUS_NED_13_METADATA&zun=METERS&prj=0&csx=9.259259260000041E-5&csy=9.259259260000041E-5&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);
// SM903HZ...SRTM 3 arc sec - Shuttle Radar Topography Mission [Finished]:
//  querySeamless.Format("http://extract.cr.usgs.gov/diststatus/servlet/gov.usgs.edc.RequestStatus?siz=1&key=SM9&ras=1&rsp=1&pfm=BIL_16INT&imsurl=-1&ms=-1&att=-1&lay=-1&fid=-1&dlpre=&lft=%f&rgt=%f&top=%f&bot=%f&wmd=1&mur=http://extract.cr.usgs.gov/distmeta/servlet/gov.usgs.edc.MetaBuilder&mcd=SRTM3FIN&mdf=HTML&arc=ZIP&sde=SRTM.C_1TO19_3_ELEVATION_SHIFT&msd=SRTM.c_world_3_elevation_meta&zun=&prj=0&csx=8.333333332999158E-4&csy=8.333333332999158E-4&bnd=&bndnm=&RC=%s",
//                        left, right, top, bottom, key19Digits);

  char drive[_MAX_DRIVE];
  char dir[_MAX_DIR];
  char seamlessFilename[_MAX_FNAME];
  char ext[_MAX_EXT];
  int nResult = 0;
  strcpy(drive, "d:");
  strcpy(dir, "\\workspace\\geoDataClient\\");
  strcpy(seamlessFilename, "00000000");
  strcpy(ext, "zip");
  nResult = request.execute(querySeamless, "", false); // Adamiker - remove this for tiling testing.
  closeButton.EnableWindow();
  // proceedButton.EnableWindow(); // Don't enable this button here.
	// CWnd *pLeft = GetDlgItem(IDC_EDIT_LEFT);
	// if(pLeft) pLeft->EnableWindow();
	// CWnd *pTop = GetDlgItem(IDC_EDIT_TOP);
	// if(pTop) pTop->EnableWindow();
  allowedToEnableProceedButton = true; // If appropriate, that button may be enabled again.
  CString zipFilename = request.getOutputFilename(); // Full path to ZIP file
  if(nResult)
  {
    SetStateError();
    return nResult;
  }
  // E. g. "D:\workspace\geoDataClient\12345678.zip"
  char zipFile[1024];
  strcpy(zipFile, zipFilename);
  char *argv[] = { "unzip", zipFile };
  int argc = 2;
  nResult = unzip(argc, argv); // Adamiker - remove this for tiling testing.
  if((nResult != 0) && (nResult != 1))
  {
    SetStateError();
    return nResult;
  }
  _splitpath(zipFilename, drive, dir, seamlessFilename, ext);
  CString bilFilename;
  bilFilename.Format("%s%s%s\\%s.bil", drive, dir, seamlessFilename, seamlessFilename); // subdir = seamlessFilename!
  CString hdrFilename;
  hdrFilename.Format("%s%s%s\\%s.hdr", drive, dir, seamlessFilename, seamlessFilename); // subdir = seamlessFilename!
  CString stxFilename;
  stxFilename.Format("%s%s%s\\%s.stx", drive, dir, seamlessFilename, seamlessFilename); // subdir = seamlessFilename!
  CString tgaFilenameElevation;
  if(outputFileNamesFromCoordinates)
  {
	  if(quadLeft <= 0.0)
	  {
		  // West of Greenwich
		  if(quadTop >= 0.0)
		  {
			  // North of the equator: 00.00000N000.00000W
			  tgaFilenameElevation.Format("%s%s%08.6fN%09.6fW_el.tga", drive, dir, quadTop, -quadLeft);
		  }
		  else
		  {
			  // South of the equator: 00.00000S000.00000W
			  tgaFilenameElevation.Format("%s%s%08.6fS%09.6fW_el.tga", drive, dir, -quadTop, -quadLeft);
		  }
	  }
	  else
	  {
		  // East of Greenwich
		  if(quadTop >= 0.0)
		  {
			  // North of the equator: 00.00000N000.00000E
			  tgaFilenameElevation.Format("%s%s%08.6fN%09.6fE_el.tga", drive, dir, quadTop, quadLeft);
		  }
		  else
		  {
			  // South of the equator: 00.00000S000.00000E
			  tgaFilenameElevation.Format("%s%s%08.6fS%09.6fE_el.tga", drive, dir, -quadTop, quadLeft);
		  }
	  }
  }
  else
  {
	  tgaFilenameElevation.Format("%s%s%s_el.tga", drive, dir, seamlessFilename);
  }

  nBILCols = nBILRows = 0;
  // E. g. "D:\workspace\geoDataClient\12345678\12345678.bil"
  nResult = BilToTga(bilFilename, hdrFilename, stxFilename, tgaFilenameElevation); // Adamiker - remove this for tiling testing.
  if(nResult)
  {
    SetStateError();
    return nResult;
  }
  // At this point, nBILCols and nBILRows contain the BIL file size.
  // Interpolate to get rid of the NODATA (zero) elevation values.
  if(interpolate)
  {
    nResult = interpolateElevation(tgaFilenameElevation, 50);
    if(nResult)
    {
      SetStateError();
      return nResult;
    }
  }
  CString bilDirectory;
  bilDirectory.Format("%s%s%s", drive, dir, seamlessFilename);
  if(removeIntermediateFiles)
  {
    nResult += RemoveDir(bilDirectory);
    nResult += !DeleteFile(zipFilename);
  }
  const int imagesize = 1200;
  const double PI = 3.14159265358979323846;
  int nWidth = int(imagesize * cos((top + bottom) * 0.5 / 180.0 * PI) + 0.5);
  int nHeight = imagesize;
  CString tgaFilenameTextureStretchedTotal;
  tgaFilenameTextureStretchedTotal.Format("%s%s%s_tx_r.tga", drive, dir, seamlessFilename);
  CString gifFilenameTexture;
  const int tileX = 0;
  const int tileY = 0;
  gifFilenameTexture.Format("%s%s%s_tx_%d%d.gif", drive, dir, seamlessFilename, tileX, tileY);
  // Call tiger.census.gov to get the texture GIF file.
  double l = 0.0;
  double r = 0.0;
  double t = 0.0;
  double b = 0.0;
  if(fabs(right - left - 0.025) < 0.00001)
  {
    const double scale = 1.000; // 0.865
    // It is a 0.025 degree query. Apply a 0.021625 offset instead a 0.025 one to avoid cutoffs.
    l = left   + scale * tileX * (right - left); // Reduce the offset to 86.5%.
    r = l                      + (right - left); // Keep the size 100%.
    b = bottom + scale * tileY * (top - bottom); // Reduce the offset to 86.5%.
    t = b                      + (top - bottom); // Keep the size 100%.
    /*
    Test with: -76.50, 38.99, 3 tiles

    If you are using 3 by 3 tiles and a 0.025 degree quadrangle,
    then make sure to:
    
    - use the uncolored mapping file instead of the one colored from the elevation file or
          use an all-white palette file;
    - resize the canvas of the elevation file to 90% its size. Keep the lower left corner point in place.
    - readjust the x, y scales in the TRF files accordingly.
    */
  }
  else
  {
    l = left + tileX * (right - left);
    r = l + (right - left);
    b = bottom + tileY * (top - bottom);
    t = b + (top - bottom);
  }
  nResult = TigerQuery(gifFilenameTexture, l, r, t, b, imagesize);
  if(nResult)
  {
    return nResult;
  }
  CString tgaFilenameTexture;
  tgaFilenameTexture.Format("%s%s%s_tx_%d%d.tga", drive, dir, seamlessFilename, tileX, tileY);
  // Convert the texture GIF file to the texture TGA file, scale 1:1
  nResult = GifToTga(gifFilenameTexture, tgaFilenameTexture);
  if(nResult)
  {
    SetStateError();
    return nResult;
  }
  CString tgaFilenameTextureStretched;
  tgaFilenameTextureStretched.Format("%s%s%s_tx_r_%d%d.tga", drive, dir, seamlessFilename, tileX, tileY);
  // Stretch the texture TGA file to match the elevation file.
  // This rectifies the texture file and changes the aspect ratio.
  double x1_ = imagesize * (1.0 - cos(t / 180.0 * PI)) * 0.5;
  double y1_ = 24.0;
  double x2_ = imagesize * (1.0 + cos(t / 180.0 * PI)) * 0.5;
  double y2_ = 24.0;
  double x3_ = imagesize * (1.0 - cos(b / 180.0 * PI)) * 0.5;
  double y3_ = 1224.0;
  double x4_ = imagesize * (1.0 + cos(b / 180.0 * PI)) * 0.5;
  double y4_ = 1224.0;

  nResult = StretchTga(tgaFilenameTexture,
                        tgaFilenameTextureStretched,
                        x1_, y1_,
                        x2_, y2_,
                        x3_, y3_,
                        x4_, y4_,
                        // E. g. if nHeight is 1200, then
                        //       nWidth is 926 for 39.5 deg lat.
                        nWidth, nHeight);
  if(nResult)
  {
    SetStateError();
    return nResult;
  }
  nResult = AddTga(tgaFilenameTextureStretched,
                    tgaFilenameTextureStretchedTotal,
                    nWidth * tileX,
                    nHeight * tileY,
                    nWidth,
                    nHeight);
  if(nResult)
  {
    SetStateError();
    return nResult;
  }
  if(removeIntermediateFiles)
  {
    nResult = !DeleteFile(gifFilenameTexture);
    nResult = !DeleteFile(tgaFilenameTexture);
    nResult = !DeleteFile(tgaFilenameTextureStretched);
  }
  CString tgaFilenameElevationColor;
  tgaFilenameElevationColor.Format("%s%s%s_el_c.tga", drive, dir, seamlessFilename);
  // Convert elevation to color using a palette [file].
  nResult = ElevationToColor(tgaFilenameElevation,
                             tgaFilenameElevationColor);
  if(nResult)
  {
    SetStateError();
    return nResult;
  }
  CString tgaFilenameTextureCombined;
  if(outputFileNamesFromCoordinates)
  {
	  if(quadLeft <= 0.0)
	  {
		  // West of Greenwich
		  if(quadTop >= 0.0)
		  {
			  // North of the equator: 00.00000N000.00000W
			  tgaFilenameTextureCombined.Format("%s%s%08.6fN%09.6fW_tx_c.tga", drive, dir, quadTop, -quadLeft);
		  }
		  else
		  {
			  // South of the equator: 00.00000S000.00000W
			  tgaFilenameTextureCombined.Format("%s%s%08.6fS%09.6fW_tx_c.tga", drive, dir, -quadTop, -quadLeft);
		  }
	  }
	  else
	  {
		  // East of Greenwich
		  if(quadTop >= 0.0)
		  {
			  // North of the equator: 00.00000N000.00000E
			  tgaFilenameTextureCombined.Format("%s%s%08.6fN%09.6fE_tx_c.tga", drive, dir, quadTop, quadLeft);
		  }
		  else
		  {
			  // South of the equator: 00.00000S000.00000E
			  tgaFilenameTextureCombined.Format("%s%s%08.6fS%09.6fE_tx_c.tga", drive, dir, -quadTop, quadLeft);
		  }
	  }
  }
  else
  {
	  tgaFilenameTextureCombined.Format("%s%s%s_tx_c.tga", drive, dir, seamlessFilename);
  }
  // Combine the two files.
  nResult = CombineTga(tgaFilenameTextureStretchedTotal,
                       tgaFilenameElevationColor,
                       tgaFilenameTextureCombined);
  if(nResult)
  {
    SetStateError();
    return nResult;
  }
  CString tgaFilenameTextureCombinedWaypoints;
  if(waypointList.size() > 0)
  {
    tgaFilenameTextureCombinedWaypoints.Format("%s%s%s_tx_cw.tga", drive, dir, seamlessFilename);
    // Add waypoints.
    nResult = AddWaypoints(tgaFilenameTextureCombined,
                           tgaFilenameTextureCombinedWaypoints,
                           left,
                           top,
                           right,
                           bottom,
                           waypointList);
    if(nResult)
    {
      SetStateError();
      return nResult;
    }
    if(removeIntermediateFiles)
    {
      nResult += !DeleteFile(tgaFilenameTextureCombined);
    }
  }
  else
  {
    tgaFilenameTextureCombinedWaypoints = tgaFilenameTextureCombined;
  }
  if(removeIntermediateFiles)
  {
    nResult += !DeleteFile(tgaFilenameTextureStretchedTotal);
    nResult += !DeleteFile(tgaFilenameElevationColor);
  }
  CString outputImageName1;
  outputImageName1.Format("%s%s%s_output_1_%%04d.tga", drive, dir, seamlessFilename);
  CString outputImageName2;
  outputImageName2.Format("%s%s%s_output_2_%%04d.tga", drive, dir, seamlessFilename);
  CStdioFile TRFFile;
  CString TRFFilename;
  if(outputFileNamesFromCoordinates)
  {
	  if(quadLeft <= 0.0)
	  {
		  // West of Greenwich
		  if(quadTop >= 0.0)
		  {
			  // North of the equator: 00.00000N000.00000W
			  TRFFilename.Format("%s%s%08.6fN%09.6fW_1.trf", drive, dir, quadTop, -quadLeft);
		  }
		  else
		  {
			  // South of the equator: 00.00000S000.00000W
			  TRFFilename.Format("%s%s%08.6fS%09.6fW_1.trf", drive, dir, -quadTop, -quadLeft);
		  }
	  }
	  else
	  {
		  // East of Greenwich
		  if(quadTop >= 0.0)
		  {
			  // North of the equator: 00.00000N000.00000E
			  TRFFilename.Format("%s%s%08.6fN%09.6fE_1.trf", drive, dir, quadTop, quadLeft);
		  }
		  else
		  {
			  // South of the equator: 00.00000S000.00000E
			  TRFFilename.Format("%s%s%08.6fS%09.6fE_1.trf", drive, dir, -quadTop, quadLeft);
		  }
	  }
  }
  else
  {
	  TRFFilename.Format("%s%s%s_1.trf", drive, dir, seamlessFilename);
  }
  if(TRFFile.Open(TRFFilename, CFile::modeCreate | CFile::modeWrite))
  {
    CString TRFFileString;
    TRFFileString.Format("[Param]\n"
                         "BeobXA=0.000000\n"
                         "BeobYA=%0.6f\n"
                         "BeobZA=%0.6f\n"
                         "RichtungA=15.000000\n"
                         "NeigungA=-34.000000\n"
                         "BrennA=1200.000000\n"
                         "VerkantenA=0.000000\n"
                         "BeobXE=%0.6f\n"
                         "BeobYE=%0.6f\n"
                         "BeobZE=%0.6f\n"
                         "RichtungE=-15.000000\n"
                         "NeigungE=-34.000000\n"
                         "BrennE=1200.000000\n"
                         "VerkantenE=0.000000\n"
                         "Bildanzahl=100\n"
                         "Offset=0\n"
                         "StartbildNr=0\n"
                         "EndbildNr=99\n"
                         "LichtX=-1.000000\n"
                         "LichtY=1.000000\n"
                         "LichtZ=-2.000000\n"
                         "NebelA=1000000.000000\n"
                         "NebelE=1000000.000000\n"
                         "Traegheit=1.000000\n"
                         "AusgabeTGA=1\n"
                         "AusgabeYUV=0\n"
                         "AusDateiname=%s\n"
                         "TDateiVerwenden=1\n"
                         "TDateiname=%s\n"
                         "HDateiname=%s\n"
                         "HDateiSkalaX=%0.6f\n"
                         "HDateiSkalaY=%0.6f\n"
                         "HDateiSkalaZA=%0.6f\n"
                         "HDateiSkalaZE=%0.6f\n"
                         "MDateiVerwenden=0\n"
                         "MaskenDateiName=\n"
                         "AusBreite=640\n"
                         "AusHoehe=480\n"
                         "AusAuflX=512\n"
                         "AusAuflY=512\n"
                         "HintergrundVerwenden=1\n"
                         "GenauRechnen=1\n"
                         "Hintergrund=A00000\n"
                         "Rundflug=0\n"
                         "HoeheUeberBoden=0.000000\n"
                         "VerkantenFaktor=0.000000\n"
                         "Voraussicht=0.000000\n"
                         "Recorder=0",
                                 -1000.0,                          // BeobYA
                                  1000.0,                          // BeobZA
                          double(nWidth),                          // BeobXE
                                 -1000.0,                          // BeobYE
                                  1000.0,                          // BeobZE
                         outputImageName1,                         // AusDateiname
                         tgaFilenameTextureCombinedWaypoints,      // TDateiname
                         tgaFilenameElevation,                     // HDateiname
                               double( nWidth) / double(nBILCols), // HDateiSkalaX
                               double(nHeight) / double(nBILRows), // HDateiSkalaY
                               zScale * 3600.0 / double(nBILCols), // HDateiSkalaZA
                               zScale * 3600.0 / double(nBILCols)  // HDateiSkalaZE
                        );
    TRFFile.WriteString(TRFFileString);
    TRFFile.Close();
    message.Format(_T("Result file written: \"%s\"."), TRFFilename);
    addMessage(message);
  if(outputFileNamesFromCoordinates)
  {
	  if(quadLeft <= 0.0)
	  {
		  // West of Greenwich
		  if(quadTop >= 0.0)
		  {
			  // North of the equator: 00.00000N000.00000W
			  TRFFilename.Format("%s%s%08.6fN%09.6fW_2.trf", drive, dir, quadTop, -quadLeft);
		  }
		  else
		  {
			  // South of the equator: 00.00000S000.00000W
			  TRFFilename.Format("%s%s%08.6fS509.6fW_2.trf", drive, dir, -quadTop, -quadLeft);
		  }
	  }
	  else
	  {
		  // East of Greenwich
		  if(quadTop >= 0.0)
		  {
			  // North of the equator: 00.00000N000.00000E
			  TRFFilename.Format("%s%s508.6fN%09.6fE_2.trf", drive, dir, quadTop, quadLeft);
		  }
		  else
		  {
			  // South of the equator: 00.00000S000.00000E
			  TRFFilename.Format("%s%s508.6fS%09.6fE_2.trf", drive, dir, -quadTop, quadLeft);
		  }
	  }
  }
  else
  {
      TRFFilename.Format("%s%s%s_2.trf", drive, dir, seamlessFilename);
  }
    if(TRFFile.Open(TRFFilename, CFile::modeCreate | CFile::modeWrite))
    {
      TRFFileString.Format("[Param]\n"
                          "BeobXA=%0.6f\n"
                          "BeobYA=%0.6f\n"
                          "BeobZA=%0.6f\n"
                          "RichtungA=45.000000\n"
                          "NeigungA=-40.000000\n"
                          "BrennA=2400.000000\n"
                          "VerkantenA=0.000000\n"
                          "BeobXE=%0.6f\n"
                          "BeobYE=%0.6f\n"
                          "BeobZE=%0.6f\n"
                          "RichtungE=0.000000\n"
                          "NeigungE=-89.999900\n"
                          "BrennE=1200.000000\n"
                          "VerkantenE=0.000000\n"
                          "Bildanzahl=100\n"
                          "Offset=0\n"
                          "StartbildNr=0\n"
                          "EndbildNr=99\n"
                          "LichtX=-1.000000\n"
                          "LichtY=1.000000\n"
                          "LichtZ=-2.000000\n"
                          "NebelA=1000000.000000\n"
                          "NebelE=1000000.000000\n"
                          "Traegheit=1.000000\n"
                          "AusgabeTGA=1\n"
                          "AusgabeYUV=0\n"
                          "AusDateiname=%s\n"
                          "TDateiVerwenden=1\n"
                          "TDateiname=%s\n"
                          "HDateiname=%s\n"
                          "HDateiSkalaX=%0.6f\n"
                          "HDateiSkalaY=%0.6f\n"
                          "HDateiSkalaZA=%0.6f\n"
                          "HDateiSkalaZE=%0.6f\n"
                          "MDateiVerwenden=0\n"
                          "MaskenDateiName=\n"
                          "AusBreite=640\n"
                          "AusHoehe=480\n"
                          "AusAuflX=512\n"
                          "AusAuflY=512\n"
                          "HintergrundVerwenden=1\n"
                          "GenauRechnen=1\n"
                          "Hintergrund=A00000\n"
                          "Rundflug=0\n"
                          "HoeheUeberBoden=0.000000\n"
                          "VerkantenFaktor=0.000000\n"
                          "Voraussicht=0.000000\n"
                          "Recorder=0",
                          -330.0,                              // BeobXA
                          -330.0,                              // BeobYA
                          1000.0,                              // BeobZA
                          double( nWidth) * 0.5,               // BeobXE
                          double(nHeight) * 0.5,               // BeobYE
                          1670.0,                              // BeobZA
                          outputImageName2,                    // AusDateiname
                          tgaFilenameTextureCombinedWaypoints, // TDateiname
                          tgaFilenameElevation,                // HDateiname
                          double( nWidth) / double(nBILCols),  // HDateiSkalaX
                          double(nHeight) / double(nBILRows),  // HDateiSkalaY.
                          zScale * 3600.0 / double(nBILCols),  // HDateiSkalaZA
                          zScale * 3600.0 / double(nBILCols)   // HDateiSkalaZE
                          );
      TRFFile.WriteString(TRFFileString);
      TRFFile.Close();
      message.Format(_T("Result file written: \"%s\"."), TRFFilename);
      addMessage(message);
      addMessage(_T("Download successfully finished."));
		char *gdcScanner = getenv("gdcScanner");
		if(gdcScanner)
		{
			if(!stricmp(gdcScanner, "yes"))
			{
				quadLeft += 0.25;
				quadRight += 0.25;
				UpdateData(FALSE);
				message.Format(_T("quadLeft = %0.6f, quadRight = %0.6f"), quadLeft, quadRight);
				addMessage(message);
			}
		}
		proceedButton.EnableWindow();
		CWnd *pLeft = GetDlgItem(IDC_EDIT_LEFT);
		if(pLeft) pLeft->EnableWindow();
		CWnd *pTop = GetDlgItem(IDC_EDIT_TOP);
		if(pTop) pTop->EnableWindow();
      return 0;
    }
    else
    {
      message.Format(_T("Could not write TRF file \"%s\"."),
                      TRFFilename);
      addMessage(message);
      addMessage(_T("Download failed. Please retry."));
      BlinkError();
      return 1;
    }
  }
  else
  {
    message.Format(_T("Could not write TRF file \"%s\"."),
                    TRFFilename);
    addMessage(message);
    addMessage(_T("Download failed. Please retry."));
    BlinkError();
    return 1;
  }
}
